gtkmm: Gtk::TextMark Class Reference

gtkmm 2.24.3

- Main Page
- Related Pages
- Modules
- Namespaces
- Classes

- Class List
- Class Index
- Class Hierarchy
- Class Members

Public Member Functions | Static Public Member Functions | Protected Member Functions | Related Functions | List of all members
Gtk::TextMark Class Reference
TextView Classes

Typedefed as Gtk::TextBuffer::Mark. More...

Inheritance diagram for Gtk::TextMark:
[legend]
Collaboration diagram for Gtk::TextMark:
[legend]

## Public Member Functions
virtual | ~TextMark ()
GtkTextMark* | gobj ()
| Provides access to the underlying C GObject. More...
const GtkTextMark* | gobj () const
| Provides access to the underlying C GObject. More...
GtkTextMark* | gobj_copy ()
| Provides access to the underlying C instance. The caller is responsible for unrefing it. Use when directly setting fields in structs. More...
void | set_visible (bool setting=true)
| Sets the visibility of mark; the insertion point is normally visible, i.e. you can see it as a vertical bar. More...
bool | get_visible () const
| Returns `true` if the mark is visible (i.e. a cursor is displayed for it). More...
Glib::ustring | get_name () const
| Returns the mark name; returns `0` for anonymous marks. More...
bool | get_deleted () const
| Returns `true` if the mark has been removed from its buffer with Gtk::TextBuffer::delete_mark(). More...
Glib::RefPtr< TextBuffer > | get_buffer ()
| Gets the buffer this mark is located inside, or `0` if the mark is deleted. More...
Glib::RefPtr< const TextBuffer > | get_buffer () const
| Gets the buffer this mark is located inside, or `0` if the mark is deleted. More...
bool | get_left_gravity () const
| Determines whether the mark has left gravity. More...
TextIter | get_iter ()
Glib::PropertyProxy_ReadOnly < Glib::ustring > | property_name () const
| Mark name. More...
Glib::PropertyProxy_ReadOnly < bool > | property_left_gravity () const
| Whether the mark has left gravity. More...
Public Member Functions inherited from Glib::Object
void * | get_data (const QueryQuark &key)
void | set_data (const Quark &key, void *data)
void | set_data (const Quark &key, void *data, DestroyNotify notify)
void | remove_data (const QueryQuark &quark)
void * | steal_data (const QueryQuark &quark)
void | set_property_value (const Glib::ustring &property_name, const Glib::ValueBase &value)
void | get_property_value (const Glib::ustring &property_name, Glib::ValueBase &value) const
void | set_property (const Glib::ustring &property_name, const PropertyType &value)
void | get_property (const Glib::ustring &property_name, PropertyType &value) const
void | connect_property_changed (const Glib::ustring &property_name, const sigc::slot< void > &slot)
sigc::connection | connect_property_changed_with_return (const Glib::ustring &property_name, const sigc::slot< void > &slot)
void | freeze_notify ()
void | thaw_notify ()
virtual void | reference () const
virtual void | unreference () const
GObject * | gobj ()
const GObject * | gobj () const
GObject * | gobj_copy () const
Glib::RefPtr< Glib::Object > | wrap (GObject *object, bool take_copy=false)
Public Member Functions inherited from Glib::ObjectBase
void | set_property_value (const Glib::ustring &property_name, const Glib::ValueBase &value)
void | get_property_value (const Glib::ustring &property_name, Glib::ValueBase &value) const
void | set_property (const Glib::ustring &property_name, const PropertyType &value)
void | get_property (const Glib::ustring &property_name, PropertyType &value) const
void | connect_property_changed (const Glib::ustring &property_name, const sigc::slot< void > &slot)
sigc::connection | connect_property_changed_with_return (const Glib::ustring &property_name, const sigc::slot< void > &slot)
void | freeze_notify ()
void | thaw_notify ()
GObject * | gobj ()
const GObject * | gobj () const
GObject * | gobj_copy () const
Public Member Functions inherited from sigc::trackable
| trackable (const trackable &src)
trackable & | operator= (const trackable &src)
void | add_destroy_notify_callback (void *data, func_destroy_notify func) const
void | remove_destroy_notify_callback (void *data) const
void | notify_callbacks ()

## Static Public Member Functions
static GType | get_type ()
| Get the GType for this class, for use with the underlying GObject type system. More...
static Glib::RefPtr< TextMark > | create (bool left_gravity=true)
| Creates an anoymous text mark. More...
static Glib::RefPtr< TextMark > | create (const Glib::ustring& name, bool left_gravity=true)
| Creates a text mark. More...

## Protected Member Functions
| TextMark (bool left_gravity=true)
| Creates an anoymous text mark. More...
| TextMark (const Glib::ustring& name, bool left_gravity=true)
| Creates a text mark. More...
Protected Member Functions inherited from Glib::Object
| Object ()
| Object (const Glib::ConstructParams &construct_params)
| Object (GObject *castitem)
virtual | ~Object ()
| ObjectBase ()
| ObjectBase (const char *custom_type_name)
| ObjectBase (const std::type_info &custom_type_info)
virtual | ~ObjectBase ()=0
void | initialize (GObject *castitem)
Protected Member Functions inherited from Glib::ObjectBase
| ObjectBase ()
| ObjectBase (const char *custom_type_name)
| ObjectBase (const std::type_info &custom_type_info)
void | initialize (GObject *castitem)

## Related Functions
(Note that these are not member functions.)
Glib::RefPtr< Gtk::TextMark > | wrap (GtkTextMark* object, bool take_copy=false)
| A Glib::wrap() method for this object. More...

## Additional Inherited Members
Public Types inherited from Glib::Object
typedef void(* | DestroyNotify )(gpointer data)

## Detailed Description

Typedefed as Gtk::TextBuffer::Mark.

A position in the buffer, preserved across buffer modifications.

A Mark is like a bookmark in a text buffer; it preserves a position in the text. Unlike iterators, marks remain valid across buffer mutations, because their behavior is defined when text is inserted or deleted. When text containing a mark is deleted, the mark remains in the position originally occupied by the deleted text. When text is inserted at a mark, a mark with left gravity will be moved to the beginning of the newly-inserted text, and a mark with right gravity will be moved to the end. The standard text cursor in left-to-right languages is a mark with right gravity, because it stays to the right of inserted text.

Like tags, marks can be either named or anonymous. There are two marks built-in to Gtk::TextBuffer; these are named "insert" and "selection_bound" and refer to the insertion point and the boundary of the selection which is not the insertion point, respectively. If no text is selected, these two marks will be in the same position. You can manipulate what is selected and where the cursor appears by moving these marks around.

"left" and "right" here refer to logical direction (left is the toward the start of the buffer); in some languages such as Hebrew the logically-leftmost text is not actually on the left when displayed.

You can convert the mark to an iterator using Gtk::TextBuffer::get_iter_at_mark().

Marks can be deleted from the buffer at any time with Gtk::TextBuffer::delete_mark(). Once deleted from the buffer, a mark is essentially useless.

Marks optionally have names; these can be convenient to avoid passing the Gtk::TextBuffer::Mark object around.

Marks are typically created using the Gtk::TextBuffer::create_mark() function.

## Constructor & Destructor Documentation

virtual Gtk::TextMark::~TextMark | ( |  | ) |
| virtual

Gtk::TextMark::TextMark | ( | bool | left_gravity = `true` | ) |
| explicitprotected

Creates an anoymous text mark.

Add it to a buffer using Gtk::TextBuffer::add_mark(). If a mark has left gravity, and text is inserted at the mark's current location, the mark will be moved to the left of the newly-inserted text. If the mark has right gravity (left_gravity = false), the mark will end up on the right of newly-inserted text. The standard left-to-right cursor is a mark with right gravity (when you type, the cursor stays on the right side of the text you're typing).

Parameters

  name | mark name.
  left_gravity | Whether the mark should have left gravity.

Since gtkmm 2.12:

Gtk::TextMark::TextMark | ( | const Glib::ustring & | name,
|  | bool | left_gravity = `true`
| ) |  |
| explicitprotected

Creates a text mark.

Add it to a buffer using Gtk::TextBuffer::add_mark(). The mark can be retrieved by name using Gtk::TextBuffer::get_mark(). If a mark has left gravity, and text is inserted at the mark's current location, the mark will be moved to the left of the newly-inserted text. If the mark has right gravity (left_gravity = false), the mark will end up on the right of newly-inserted text. The standard left-to-right cursor is a mark with right gravity (when you type, the cursor stays on the right side of the text you're typing).

Parameters

  name | mark name.
  left_gravity | Whether the mark should have left gravity.

Since gtkmm 2.12:

## Member Function Documentation

static Glib::RefPtr<TextMark> Gtk::TextMark::create | ( | bool | left_gravity = `true` | ) |
| static

Creates an anoymous text mark.

Add it to a buffer using Gtk::TextBuffer::add_mark(). If a mark has left gravity, and text is inserted at the mark's current location, the mark will be moved to the left of the newly-inserted text. If the mark has right gravity (left_gravity = false), the mark will end up on the right of newly-inserted text. The standard left-to-right cursor is a mark with right gravity (when you type, the cursor stays on the right side of the text you're typing).

Parameters

  name | mark name.
  left_gravity | Whether the mark should have left gravity.

Returns
  A RefPtr to a new text mark.

Since gtkmm 2.12:

static Glib::RefPtr<TextMark> Gtk::TextMark::create | ( | const Glib::ustring & | name,
|  | bool | left_gravity = `true`
| ) |  |
| static

Creates a text mark.

Add it to a buffer using Gtk::TextBuffer::add_mark(). The mark can be retrieved by name using Gtk::TextBuffer::get_mark(). If a mark has left gravity, and text is inserted at the mark's current location, the mark will be moved to the left of the newly-inserted text. If the mark has right gravity (left_gravity = false), the mark will end up on the right of newly-inserted text. The standard left-to-right cursor is a mark with right gravity (when you type, the cursor stays on the right side of the text you're typing).

Parameters

  name | mark name.
  left_gravity | Whether the mark should have left gravity.

Returns
  A RefPtr to a new text mark.

Since gtkmm 2.12:

Glib::RefPtr<TextBuffer> Gtk::TextMark::get_buffer | ( |  | ) |

Gets the buffer this mark is located inside, or `0` if the mark is deleted.

Returns
  The mark's Gtk::TextBuffer.

Glib::RefPtr<const TextBuffer> Gtk::TextMark::get_buffer | ( |  | ) | const

Gets the buffer this mark is located inside, or `0` if the mark is deleted.

Returns
  The mark's Gtk::TextBuffer.

bool Gtk::TextMark::get_deleted | ( |  | ) | const

Returns `true` if the mark has been removed from its buffer with Gtk::TextBuffer::delete_mark().

See Gtk::TextBuffer::add_mark() for a way to add it to a buffer again.

Returns
  Whether the mark is deleted.

TextIter Gtk::TextMark::get_iter | ( |  | ) |

bool Gtk::TextMark::get_left_gravity | ( |  | ) | const

Determines whether the mark has left gravity.

Returns
  `true` if the mark has left gravity, `false` otherwise.

Glib::ustring Gtk::TextMark::get_name | ( |  | ) | const

Returns the mark name; returns `0` for anonymous marks.

Returns
  Mark name.

static GType Gtk::TextMark::get_type | ( |  | ) |
| static

Get the GType for this class, for use with the underlying GObject type system.

bool Gtk::TextMark::get_visible | ( |  | ) | const

Returns `true` if the mark is visible (i.e. a cursor is displayed for it).

Returns
  `true` if visible.

GtkTextMark* Gtk::TextMark::gobj | ( |  | ) |
| inline

Provides access to the underlying C GObject.

const GtkTextMark* Gtk::TextMark::gobj | ( |  | ) | const
| inline

Provides access to the underlying C GObject.

GtkTextMark* Gtk::TextMark::gobj_copy | ( |  | ) |

Provides access to the underlying C instance. The caller is responsible for unrefing it. Use when directly setting fields in structs.

Glib::PropertyProxy_ReadOnly< bool > Gtk::TextMark::property_left_gravity | ( |  | ) | const

Whether the mark has left gravity.

You rarely need to use properties because there are get_ and set_ methods for almost all of them.

Returns
  A PropertyProxy_ReadOnly that allows you to get the value of the property, or receive notification when the value of the property changes.

Glib::PropertyProxy_ReadOnly< Glib::ustring > Gtk::TextMark::property_name | ( |  | ) | const

Mark name.

You rarely need to use properties because there are get_ and set_ methods for almost all of them.

Returns
  A PropertyProxy_ReadOnly that allows you to get the value of the property, or receive notification when the value of the property changes.

void Gtk::TextMark::set_visible | ( | bool | setting = `true` | ) |

Sets the visibility of mark; the insertion point is normally visible, i.e. you can see it as a vertical bar.

Also, the text widget uses a visible mark to indicate where a drop will occur when dragging-and-dropping text. Most other marks are not visible. Marks are not visible by default.

Parameters

  setting | Visibility of mark.

## Friends And Related Function Documentation

Glib::RefPtr< Gtk::TextMark > wrap | ( | GtkTextMark * | object,
|  | bool | take_copy = `false`
| ) |  |
| related

A Glib::wrap() method for this object.

Parameters

  object | The C instance.
  take_copy | False if the result should take ownership of the C instance. True if it should take a new copy or ref.

Returns
  A C++ instance that wraps this C instance.

The documentation for this class was generated from the following file:

- gtkmm/textmark.h